routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\AdminController;
use App\Http\Controllers\BlogController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\ClientController;
use App\Http\Controllers\ContactController;
use App\Http\Controllers\PartnerController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\VideoController;
use App\Http\Controllers\VolunteerController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/


Route::middleware('auth')->group(function () {
    Route::redirect('/', 'admin-dashboard');
    Route::get('admin-dashboard', [AdminController::class, 'index'])->name('admin.dashboard');

    Route::get('/blog-categories',                [CategoryController::class, 'index'])->name('blog.categories.index');
    Route::post('/blog-categories',               [CategoryController::class, 'store'])->name('blog.categories.store');
    Route::get('/blog-categories/{category}/edit',[CategoryController::class, 'edit'])->name('blog.categories.edit');
    Route::put('/blog-categories/{category}',     [CategoryController::class, 'update'])->name('blog.categories.update');
    Route::delete('/blog-categories/{category}',  [CategoryController::class, 'destroy'])->name('blog.categories.destroy');

    Route::get('/blogs',            [BlogController::class, 'index'])->name('blogs.index');
    Route::get('/blogs/create',     [BlogController::class, 'create'])->name('blogs.create');
    Route::post('/blogs',           [BlogController::class, 'store'])->name('blogs.store');
    Route::get('/blogs/{blog}/edit',[BlogController::class, 'edit'])->name('blogs.edit');
    Route::put('/blogs/{blog}',     [BlogController::class, 'update'])->name('blogs.update');
    Route::delete('/blogs/{blog}',  [BlogController::class, 'destroy'])->name('blogs.destroy');

    Route::get('/videos',              [VideoController::class, 'index'])->name('videos.index');
    Route::get('/videos/create',       [VideoController::class, 'create'])->name('videos.create');
    Route::post('/videos',             [VideoController::class, 'store'])->name('videos.store');
    Route::get('/videos/{video}/edit', [VideoController::class, 'edit'])->name('videos.edit');
    Route::put('/videos/{video}',      [VideoController::class, 'update'])->name('videos.update');
    Route::delete('/videos/{video}',   [VideoController::class, 'destroy'])->name('videos.destroy');

    Route::resource('partners', PartnerController::class);

    Route::get('/clients',                   [ClientController::class, 'index'])->name('clients.index');
    Route::post('/clients',                  [ClientController::class, 'store'])->name('clients.store');
    Route::get('/clients/create',            [ClientController::class, 'create'])->name('clients.create');
    Route::delete('/clients/{client}',       [ClientController::class, 'destroy'])->name('clients.destroy');
    Route::post('/clients/{client}/active',  [ClientController::class, 'active'])->name('clients.active');
    Route::post('/clients/{client}/complete',[ClientController::class, 'complete'])->name('clients.complete');
    Route::get('clients/donations',          [ClientController::class, 'donations'])->name('clients.donations');
    Route::post('clients/donate',            [ClientController::class, 'donate'])->name('clients.donate');

    Route::get('volunteers',                       [VolunteerController::class, 'index'])->name('volunteers.index');
    Route::delete('/volunteers/{volunteer}',       [VolunteerController::class, 'destroy'])->name('volunteers.destroy');
    Route::post('/volunteers/{volunteer}/active',  [VolunteerController::class, 'active'])->name('volunteers.active');
    Route::post('/volunteers/{volunteer}/inactive',[VolunteerController::class, 'inactive'])->name('volunteers.inactive');

    Route::get('contacts',                     [ContactController::class, 'index'])->name('contacts.index');
    Route::delete('/contacts/{contact}',       [ContactController::class, 'destroy'])->name('contacts.destroy');
    Route::post('/contacts/{contact}/active',  [ContactController::class, 'active'])->name('contacts.active');
    Route::post('/contacts/{contact}/inactive',[ContactController::class, 'inactive'])->name('contacts.inactive');

});


Route::middleware('auth')->group(function () {
    Route::get('/profile', [ProfileController::class, 'edit'])->name('profile.edit');
    Route::patch('/profile', [ProfileController::class, 'update'])->name('profile.update');
    Route::delete('/profile', [ProfileController::class, 'destroy'])->name('profile.destroy');
});

require __DIR__ . '/auth.php';

app/Models/Partner.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Partner extends Model
{
    use HasFactory;

    public function partnerType()
    {
        return $this->belongsTo(PartnerType::class);
    }
}

app/Models/PartnerType.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class PartnerType extends Model
{
    use HasFactory;

    public function partners()
    {
        return $this->HasMany(Partner::class);
    }
}

app/Http/Controllers/PartnerController.php
<?php

namespace App\Http\Controllers;

use App\Models\Partner;
use App\Models\PartnerType;
use Illuminate\Support\Facades\Storage;
use App\Http\Requests\StorePartnerRequest;
use App\Http\Requests\UpdatePartnerRequest;

class PartnerController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $partners = Partner::all();
        return view('partners.index', compact('partners'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        $partnerTypes = PartnerType::all();

        return view('partners.create', compact('partnerTypes'));
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(StorePartnerRequest $request)
    {
        $partner = new Partner();
        $partner->name = $request->name;
        $partner->website = $request->website;
        $partner->partner_type_id = $request->partner_type_id;

        $image = $request->file('image');
        $fileName = md5($image->getClientOriginalName() . time()) . '.' . $image->getClientOriginalExtension();
        $filePath = 'uploads/' . $fileName;
        Storage::disk('public')->put($filePath, file_get_contents($request->file('image')));
        $partner->image = $filePath;

        if ($partner->save()) {
            return redirect()->route('partners.create')->with(['success' => 'The partner has been created']);
        }

        return redirect()->route('partners.create')->with(['error' => 'Something went wrong']);
    }

    /**
     * Display the specified resource.
     */
    public function show(Partner $partner)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Partner $partner)
    {
        $partnerTypes = PartnerType::all();
        return view('partners.edit', compact(['partner', 'partnerTypes']));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(UpdatePartnerRequest $request, Partner $partner)
    {
        $partner->name = $request->name;
        $partner->website = $request->website;
        $partner->partner_type_id = $request->partner_type_id;

        if ($request->hasFile('image')) {

            if (Storage::disk('public')->exists($partner->image)) {
                Storage::disk('public')->delete($partner->image);
            }

            $image = $request->file('image');
            $fileName = md5($image->getClientOriginalName() . time()) . '.' . $image->getClientOriginalExtension();
            $filePath = 'uploads/' . $fileName;
            Storage::disk('public')->put($filePath, file_get_contents($request->file('image')));
            $partner->image = $filePath;
        }

        if ($partner->save()) {
            return redirect()->route('partners.index')->with(['success' => 'The partner has been updated']);
        }

        return redirect()->route('partners.index')->with(['error' => 'Something went wrong']);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Partner $partner)
    {
        if (Storage::disk('public')->exists($partner->image)) {
            Storage::disk('public')->delete($partner->image);
        }

        if ($partner->delete()) {
            return redirect()->route('partners.index')->with('success', 'The partner has been deleted successfuly');
        }

        return redirect()->route('partners.index')->with('error', 'Something went wrong...');
    }
}

resources/views/partners/create.blade.php
@extends('partials.main')


@section('title', 'Create partners')
@section('content')

<div class="container-fluid">
    <div class="row">
        <div class="col-12">
            <div class="card-header">
                <div class="d-flex align-items-center justify-content-between">
                    <p class="mb-0">Create a new partner</p>
                    <a href=" {{ route('partners.index') }}" class="btn btn-info">Back</a>
                </div>
            </div>
            <div class="card-body">
                @if(Session::has('error'))
                <div class="alert alet-danger">
                    {{ Session::get('error')}}
                </div>
                @elseif(Session::has('success'))
                <div class="alert alert-success">
                    {{ Session::get('success')}}
                </div>
                @endif
                <form action=" {{ route('partners.store') }}" method="POST" enctype="multipart/form-data">
                    @csrf
                    <div class="form-group">
                        <label for="name">Name</label>
                        <input type="text" class="form-control @error('name') is-invalid @enderror" name="name" id="name" value="{{old('name')}}" placeholder="Partner name">
                        @error('name')
                        <div class="invalid-feedback">
                            {{ $message }}
                        </div>
                        @enderror
                    </div>

                    <div class="form-group">
                        <label for="url">Website</label>
                        <input type="text" class="form-control @error('website') is-invalid @enderror" name="website" id="website" value="{{old('website')}}" placeholder="Website URL">
                        @error('website')
                        <div class="invalid-feedback">
                            {{ $message }}
                        </div>
                        @enderror
                    </div>

                    <div class="form-group">
                        <label for="partner_type_id">Partner Type</label>
                        <select name="partner_type_id" id="partner_type_id" class="form-control @error('partner_type_id') is-invalid @enderror">
                            <option value="-1">Select type of partner...</option>
                            @foreach($partnerTypes as $partnerType)
                            <option value="{{ $partnerType->id }}" @if(old('partner_type_id') !=null && old('partner_type_id')==$partnerType->id) selected @endif>{{ $partnerType->name }}</option>
                            @endforeach
                        </select>
                        @error('partner_type_id')
                        <div class="invalid-feedback">
                            {{ $message }}
                        </div>
                        @enderror
                    </div>

                    <div class="form-group">
                        <label for="image">Image</label>
                        <input type="file" name="image" id="image" class="form-control @error('image') is-invalid @enderror">
                        @error('image')
                        <div class="invalid-feedback">
                            {{ $message }}
                        </div>
                        @enderror
                    </div>

                    <button type="submit" class="btn btn-success">Create</button>
                </form>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/partners/edit.blade.php
@extends('partials.main')



@section('content')

<div class="container-fluid">
    <div class="row">
        <div class="col-12">
            <div class="card-header">
                <div class="d-flex align-items-center justify-content-between">
                    <p class="mb-0">Update partner</p>
                    <a href=" {{ route('partners.index') }}" class="btn btn-info">Back</a>
                </div>
            </div>
            <div class="card-body">
                <form action=" {{ route('partners.update', $partner->id) }}" method="POST" enctype="multipart/form-data">
                    @csrf
                    @method('PUT')
                    <div class="form-group">
                        <label for="name">Name</label>
                        <input type="text" class="form-control @error('name') is-invalid @enderror" name="name" id="name" value="{{old('name', $partner->name)}}" placeholder="Partner name">
                        @error('name')
                        <div class="invalid-feedback">
                            {{ $message }}
                        </div>
                        @enderror
                    </div>

                    <div class="form-group">
                        <label for="url">Website</label>
                        <input type="text" class="form-control @error('website') is-invalid @enderror" name="website" id="website" value="{{old('website', $partner->website)}}" placeholder="Website URL">
                        @error('website')
                        <div class="invalid-feedback">
                            {{ $message }}
                        </div>
                        @enderror
                    </div>

                    <div class="form-group">
                        <label for="partner_type_id">Partner Type</label>
                        <select name="partner_type_id" id="partner_type_id" class="form-control @error('partner_type_id') is-invalid @enderror">
                            <option value="-1">Select type of partner...</option>
                            @foreach($partnerTypes as $partnerType)
                            <option value="{{ $partnerType->id }}" @if((old('partner_type_id') !=null && old('partner_type_id')==$partnerType->id) || ($partner->partner_type_id == $partnerType->id )) selected @endif>{{ $partnerType->name }}</option>
                            @endforeach
                        </select>
                        @error('partner_type_id')
                        <div class="invalid-feedback">
                            {{ $message }}
                        </div>
                        @enderror
                    </div>

                    <div class="form-group">
                        <label for="image">Image</label>
                        <input type="file" name="image" id="image" class="form-control @error('image') is-invalid @enderror">
                        <img src=" {{ asset('storage/' . $partner->image) }}" class="img-fluid" height="100px" width="100px"></img>
                        @error('image')
                        <div class="invalid-feedback">
                            {{ $message }}
                        </div>
                        @enderror
                    </div>

                    <button type="submit" class="btn btn-success">Update</button>
                </form>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/partners/index.blade.php
@extends('partials.main')


@section('title', 'Partners')
@section('content')

<div class="container-fluid">
    <div class="row">
        <div class="col-12">
            <div class="row">
                <div class="col-12">
                    <h4>Partners</h4>
                </div>
                <div class="col-12 mt-5">
                    @if(Session::has('error'))
                    <div class="alert alert-danger">
                        {{ Session::get('error')}}
                    </div>
                    @elseif(Session::has('success'))
                    <div class="alert alert-success">
                        {{ Session::get('success')}}
                    </div>
                    @endif
                    <a href=" {{ route('partners.create') }}" class="btn btn-info">Create a new partner</a>
                </div>
                <div class="col-10 offset-1">
                    <table class="table table-hover">
                        <thead>
                            <tr>
                                <th scope="col">id</th>
                                <th scope="col">name</th>
                                <th scope="col">image</th>
                                <th scope="col">website</th>
                                <th scope="col">type</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach ( $partners as $partner )
                            <tr>
                                <th>{{$partner->id}}</th>
                                <th>{{$partner->name}}</th>
                                <th><a href="storage/{{$partner->image}}" target="#"><img src=" {{ asset('storage/' . $partner->image) }}" class="" height="100px" width="200px"></img></a></th>
                                <th class="text-wraps"><a href="{{$partner->website}}" target="#">{{$partner->website}}</a></th>
                                <th>{{$partner->partnerType->name}}</th>
                                <th><a href=" {{ route('partners.edit', $partner->id) }}" class="btn btn-outline-warning">Edit</a> </th>
                                <th>
                                    <form id="delete-form" action=" {{ route('partners.destroy', $partner->id) }}" method="POST">
                                        @csrf
                                        @method('DELETE')
                                        <button type="submit" class="btn btn-outline-danger delete">Delete</button>
                                    </form>
                                </th>
                            </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('scripts')
<script>
    $(document).ready(function() {
        $(".delete").click(function(e) {
            e.preventDefault();
            Swal.fire({
                title: "Are you sure you want to delete this partner?",
                text: "- By deleting it all the information relating to this partner will be deleted aswell",
                icon: "warning",
                showCancelButton: true,
                confirmButtonColor: "#3085d6",
                cancelButtonColor: "#d33",
                confirmButtonText: "Yes, delete the partner!",
            }).then((result) => {
                if (result.isConfirmed) {
                    $('#delete-form').submit();
                }
            });
        });
    });
</script>
@endsection